<script lang="ts">
import Vue from 'vue';
import Input from '~/components/calculator/input.vue';

export default Vue.extend({
  name: 'GuestCalculator',
  components: {
    Input,
  },
  props: {
    data: {
      type: Object,
      required: true,
      default: null,
    },
  },
  data() {
    return {
      formData: {
        numberOfSeats: 0,
        numberOfGuests: 0,
      },
      ultimatePrice: 99,
      premiumPrice: 24,
    };
  },
  computed: {
    resultPremium() {
      return (
        (this.formData.numberOfSeats + this.formData.numberOfGuests) *
        this.premiumPrice
      );
    },
    resultUltimate() {
      return this.formData.numberOfSeats * this.ultimatePrice;
    },
  },
  methods: {
    pushDataLayer() {
      // eslint-disable-next-line no-undef
      dataLayer.push({
        event: 'guestUsersCalculator',
        eventTimeout: 3000,
      });
    },
  },
});
</script>

<template>
  <section :id="data.id" class="guest-calculator-section">
    <div class="guest-calculator">
      <div class="guest-calculator__wrapper">
        <SlpTypography tag="h3" variant="heading4-bold">
          {{ data.title }}
        </SlpTypography>
        <div class="guest-calculator__input-wrapper">
          <div class="guest-calculator__inputs">
            <SlpTypography tag="p" variant="body1">
              {{ data.input_title }}
            </SlpTypography>
            <label class="guest-calculator__inputs-label" for="numberOfSeats">
              {{ data.seats.title }}
              <SlpTooltip
                id="numberOfSeats"
                position="top"
                mode="click"
                data-ga-name="seats info"
                data-ga-location="guest calculator"
                :text="data.seats.tooltip"
                class="tooltip"
              >
                <SlpIcon variant="product" name="information-o"
              /></SlpTooltip>
            </label>
            <Input
              id="numberOfSeats"
              v-model.number="formData.numberOfSeats"
              @input="pushDataLayer"
            />
            <label class="guest-calculator__inputs-label" for="numberOfGuests">
              {{ data.guests.title }}
              <SlpTooltip
                id="numberOfGuests"
                position="top"
                mode="click"
                data-ga-name="guest info"
                data-ga-location="guest calculator"
                :text="data.guests.tooltip"
                class="tooltip"
              >
                <SlpIcon variant="product" name="information-o"
              /></SlpTooltip>
            </label>
            <Input
              id="numberOfGuests"
              v-model.number="formData.numberOfGuests"
              @input="pushDataLayer"
            />
          </div>
          <div class="guest-calculator__output">
            <div class="guest-calculator__output-premium">
              <SlpTypography tag="p" variant="body1">
                {{ data.premium.title }}
              </SlpTypography>
              <SlpTypography
                tag="span"
                variant="heading3-bold"
                class="guest-calculator__output-premium-result"
              >
                ${{ resultPremium.toLocaleString() }}
              </SlpTypography>
              <SlpButton
                :href="data.premium.link"
                :data-ga-name="data.premium.data_ga_name"
                :data-ga-location="data.premium.data_ga_location"
                type="button"
                variant="primary"
              >
                {{ data.premium.button }}
              </SlpButton>
            </div>
            <div class="guest-calculator__output-ultimate">
              <SlpTypography tag="p" variant="body1">
                {{ data.ultimate.title }}
              </SlpTypography>
              <SlpTypography
                tag="span"
                variant="heading3-bold"
                class="guest-calculator__output-ultimate-result"
              >
                ${{ resultUltimate.toLocaleString() }}
              </SlpTypography>
              <SlpButton
                :href="data.premium.link"
                :data-ga-name="data.ultimate.data_ga_name"
                :data-ga-location="data.ultimate.data_ga_location"
                type="button"
                variant="primary"
              >
                {{ data.ultimate.button }}
              </SlpButton>
            </div>
          </div>
        </div>
      </div>
    </div>
    <div
      v-if="data.caption"
      class="caption"
      v-html="$md.render(data.caption)"
    ></div>
  </section>
</template>

<style lang="scss" scoped>
.guest-calculator-section {
  .guest-calculator {
    width: 100%;
    background: $color-surface-950;
    border-radius: 8px;
    padding: $spacing-24 20px $spacing-32;

    &__input-wrapper {
      display: flex;
      margin-top: $spacing-24;

      @media (max-width: $breakpoint-lg) {
        flex-direction: column;
        margin-top: $spacing-16;
      }
    }

    &__inputs {
      width: 42%;
      box-sizing: border-box;
      padding-right: $spacing-24;
      border-right: $border-width solid $color-surface-400;

      &-label {
        margin: $spacing-16 0 $spacing-8;
        display: flex;
      }

      .tooltip {
        border: 0;
        cursor: pointer;
      }

      @media (max-width: $breakpoint-lg) {
        width: 100%;
        border-right: 0;
        border-bottom: $border-width solid $color-surface-400;
        padding: 0 0 $spacing-24 0;
      }
    }

    &__output {
      width: 58%;
      box-sizing: border-box;
      display: flex;
      padding-left: $spacing-24;
      align-items: center;
      gap: $spacing-24;

      &-ultimate,
      &-premium {
        display: flex;
        flex-direction: column;

        &-result {
          margin: $spacing-8 0;
        }
      }

      .slp-text-body1 {
        max-width: 200px;
      }
      .slp-btn-primary {
        width: fit-content;
      }

      @media (max-width: $breakpoint-lg) {
        width: 100%;
        padding-top: $spacing-24;
        padding-left: 0;
        flex-direction: column;
        align-items: flex-start;

        &-ultimate,
        &-premium {
          width: 100%;
        }
        .slp-btn-primary {
          width: 100%;
          display: block;
        }

        .slp-text-body1 {
          max-width: 100%;
        }
      }
    }
  }

  .caption {
    width: 100%;
    display: block;
    color: $color-text-200;
    margin-top: $spacing-16;
    font-size: $text-body-3;
    text-align: left;

    &::v-deep p a {
      color: $color-text-200;
      text-decoration: underline;
    }
  }
}
</style>
